#!/usr/bin/env perl
# Norman Kuring

our $gifsperpage	= 3;
our $caption_file =
   "/web/oceancolor/htdocs/SeaWiFS/SEASTAR/SeaStar_Photo_Captions.text";
our $thisScript = '/cgi/' . (split /\//,$0)[-1];
our $trpath = "/data1/www-data/oceancolor.gsfc.nasa.gov/htdocs/seawifs/images/";
opendir DIR,$trpath or die qq@Could not open directory, "$trpath". ($!) Died@;
our @gifs = grep /\.thumbnail\.gif$/, readdir DIR;
our $numgifs = @gifs;
our $numpages = int(($numgifs - 1) / $gifsperpage + 1);
our ($page) = $ENV{QUERY_STRING} =~ /^(\d+)$/;
$page = 1 unless defined $page;
$page = $numpages if($page > $numpages);
our $first = ($page - 1) * $gifsperpage;
our $last = $page * $gifsperpage - 1;
our $path = '/seawifs/images';

# Read in all of the captions and index them by the image ID.
open CAPTIONS, '<', $caption_file or die "Could not open $caption_file ($!)";
our $all_text = join("",<CAPTIONS>);
close CAPTIONS;
our @captions = split(/\n<P>\n/, $all_text);
while($_ = shift(@captions)){
  s@<KEYWORDS>[^000]*</KEYWORDS>@@im;
  s/^(SS\d+)$//m;
  $caption{$1} = $_;
}

# Print out the initial HTML.
print <<"--";
Content-type: text/html

<html lang="en">
<head>
<title>SeaStar Image Catalog: Page $page of $numpages</title>
</head>
<body>
<h1>
<a href="http://www.geoeye.com"><img
src="/seawifs/images/osc_logo_trans.gif"
border="0" width="256" height="55"></a>
SeaStar Image Catalog
</h1>
<h2>Page $page of $numpages</h2>
--

# Display the list of page links.
&pagelinks;

# Display the thumbnail image and its name as links to the big gif image.
# Also display the dimensions of the big gif, the size of the big gif file
# in bytes, and any caption that might be available.
our $i;
for($i = $first; $i <= $last && $i < $numgifs; $i++){
  my ($name,$biggif,$thumbnail);
  $name = $biggif = $thumbnail = $gifs[$i];
  $biggif =~ s/\.thumbnail//;
  $name =~ s/\.thumbnail\.gif//;
  open GIF,'<',"$trpath/$biggif" or warn "Could not open $trpath/$biggif\n";
  my ($w1,$w2,$h1,$h2) = unpack "x6H2H2H2H2",<GIF>;	# Get image dimensions
  my $width = hex("$w2$w1");				# Swap bytes
  my $height = hex("$h2$h1");				# Swap bytes
  close GIF;
  my $bytes = -s "$trpath/$biggif";
  print <<"  --";
  <a href="$path/$biggif"><img align="middle"
  src="$path/$thumbnail"> <b>$name</b></a>
  Dimensions: <b>$width</b> x <b>$height</b>
  Bytes: <b>$bytes</b>
  <br />
  $caption{$name}
  <p>
  --
}

# Display the list of page links again.
print <<"--";
<p>
<hr />
You may also view images on the following pages.
<p>
--
&pagelinks;

# Print out the end matter.
print <<"--";
<hr />
<a href="/seawifs/"><img
src="/icons/biosphere_globe_icon.gif">
<b>SeaWiFS Project Home Page</b></a>
<hr />
<address>
<a href="/staff/gene/">gene carl feldman</a>
(<a href="mailto:gene.c.feldman\@nasa.gov">gene.c.feldman\@nasa.gov</a>)
(301) 286-9428
</address>
</body>
</html>
--


sub pagelinks{
  my $i;
  for($i = 1; $i <= $numpages; $i++){
    if($i == $page){
      print "$i\n";
      next;
    }
    print <<"    --";
    <a href="$thisScript$path?$i"><b>$i</b></a>
    --
  }
  print "<p>\n";
}
