#!/usr/bin/env perl

# Norman Kuring		24-Jul-2000
# Norman Kuring		23-Sep-2002
# Norman Kuring		 4-Jan-2005	New webserver (Sun)
# Norman Kuring		10-Sep-2008	Add launder() subroutine.

our $imgdir = '/web/data/AVIRIS';

our $thisScript = '/cgi/' . (split /\//, $0)[-1];

our $identify = 'identify';

use OBPG::CGI qw(ReadParse);
our %in = ReadParse();

use OBPG::Launder qw(launder);

# Filter out shell metacharacters
foreach my $key ( keys %in ){
  $in{$key} = launder( $in{$key}, "\$in{$key}" );
}

if(defined $in{FN}){
  opendir D,$imgdir or die qq@Could not open directory, "$imgdir". ($!) Died@;
  my @files = map launder($_),
              sort grep /^$in{FN}.*\.v1\.27\.18\.10\.jpg$/, readdir D;
  closedir D;

  my $map = '';
  if(-s "$imgdir/$in{FN}.gif"){
    my ($w,$h) = split /x/, (split " ",`$identify $imgdir/$in{FN}.gif`,3)[1];
    $map =
    qq@<img src="$thisScript/$in{FN}.gif" width="$w" height="$h"@ .
    qq@ alt="$in{FN}.gif">\n@;
  }

  print
  qq@Content-type: text/html\n\n@,
  qq@<html lang="en">\n@,
  qq@<head><title>AVIRIS : $in{FN}</title></head>\n@,
  qq@<body>\n@,
  qq@<h1>AVIRIS : $in{FN}</h1>\n@,
  $map,
  qq@<center>\n@,
  qq@<table border="0" cellspacing="0" cellpadding="0">\n@;
  foreach (@files){
    my ($w,$h) = split /x/, (split " ",`$identify $imgdir/$_`,3)[1];
    print
    qq@<tr>\n@,
    qq@<td><img src="$thisScript/$_" width="$w" height="$h" alt="$_"></td>\n@,
    qq@<td>$_</td>\n</tr>\n@;
  }
  print
  "</center>\n",
  "</table>\n",
  "</body>\n",
  "</html>\n";
}
elsif(defined $ENV{PATH_INFO}){
  my $format = '*';
  if($ENV{PATH_INFO} =~ /jpe?g$/i){
    $format = 'jpeg';
  }
  elsif($ENV{PATH_INFO} =~ /gif$/i){
    $format = 'gif';
  }
  open F,'<',"$imgdir$ENV{PATH_INFO}" or die qq@Could not open file, @,
                                         qq@"$imgdir$ENV{PATH_INFO}". @,
                                         qq@($!) Died@;
  local($/) = undef;
  my $img = <F>;
  close F;
  my $len = length $img;
  print "Content-type: image/$format\nContent-length: $len\n\n$img";
}
