#!/usr/bin/env perl

use CGI qw(:all);
#use CGI::Pretty;
use OBPG::headfoot qw(standard_header standard_footer basic_laundry);
#require "/web/oceancolor/cgi/headfoot_pjw.cgi";
use strict;

our $path = "/data1/www-data/oceancolor.gsfc.nasa.gov/cgi/giopsens.cgi";
our $headfoot_path = "giopsens.cgi";
our $idir = "../analysis/giopsens";
our $fdir = "/data1/www-data/oceancolor.gsfc.nasa.gov/static/analysis/giopsens";


our $style=<<END;
<!--
PRE{ font-size: 10; }
-->
END

our %base = ();
$base{base_aphm10}	= 'baseline vs. chl-10%';
$base{base_aphm33}	= 'baseline vs. chl-33%';
$base{base_aphp10}	= 'baseline vs. chl+10%';
$base{base_aphp33}	= 'baseline vs. chl+33%';
$base{base_caph}	= 'baseline vs. Ciotti Sf=0.5';
$base{base_etam10}	= 'baseline vs. eta-10%';
$base{base_etam33}	= 'baseline vs. eta-33%';
$base{base_etap10}	= 'baseline vs. eta+10%';
$base{base_etap33}	= 'baseline vs. eta+33%';
$base{base_g88}		= 'baseline vs. Gordon 88';
$base{base_gaph}	= 'baseline vs. GSM aph';
$base{base_lm5}		= 'baseline vs. L-M 5-wl';
$base{base_sdgm10}	= 'baseline vs. Sdg-10%';
$base{base_sdgm33}	= 'baseline vs. Sdg-33%';
$base{base_sdgp10}	= 'baseline vs. Sdg+10%';
$base{base_sdgp33}	= 'baseline vs. Sdg+33%';
$base{base_svd6}	= 'baseline vs. SVD';
$base{base_tflat}	= 'baseline vs. flat t';
$base{lm5_svd5}		= 'L-M 5-wl vs. SVD 5-wl';
$base{base_osdg}	= 'baseline vs. OBPG Sdg';
$base{base_qsdg}	= 'L-M 5-wl vs. QAA Sdg';

our @base = qw(base_tflat base_g88 base_svd6 base_lm5 lm5_svd5 base_caph base_gaph base_aphm10 base_aphm33 base_aphp10 
base_aphp33 base_etam10 base_etam33 base_etap10 base_etap33 base_sdgm10 base_sdgm33 base_sdgp10 base_sdgp33 base_qsdg base_osdg);



#standard_header('GIOP sensitivity analyses',$path,$style);
standard_header('GIOP sensitivity analyses',$headfoot_path,$style);

print (br);
print center(h1("GIOP sensitivity analyses"));
print (hr);


print "<center>\n";
print h4("Baseline indicates preliminary configuration");

foreach my $i (@base) {
	
	print "<em>$base{$i}</em>\n";
	print "<table cellpadding=5 border=0>\n";

	open (FILE,'<',"$fdir/nomad/giop_eval_stats_$i.txt") or next;
	local($/) = undef;
	my $text1 = <FILE>;
	close (FILE);

	open (FILE,'<',"$fdir/nomad/giop_eval_diff_$i.txt") or next;
	local($/) = undef;
	my $text2 = <FILE>;
	close (FILE);

	print "<tr>\n";
		print "<td>NOMAD</td>\n";
		print "<td>\n";
			print a({-href=>"$idir/nomad/giop_eval_scat_$i.png"}, img{-src=>"$idir/nomad/giop_eval_scat_$i\_sm.png"});
		print "</td>\n";
		print "<td>\n";
			print a({-href=>"$idir/nomad/giop_eval_diff_$i.png"}, img{-src=>"$idir/nomad/giop_eval_diff_$i\_sm.png"});
		print "</td>\n";
		print "<td>\n";
			print a({-href=>"$idir/nomad/giop_eval_histd_$i.png"}, img{-src=>"$idir/nomad/giop_eval_histd_$i\_sm.png"});
		print "</td>\n";
		print "<td>\n";
			print a({-href=>"$idir/nomad/giop_eval_stats_$i.png"}, img{-src=>"$idir/nomad/giop_eval_stats_$i\_sm.png"});
		print "</td>\n";
		print "<td>\n";
			print pre($text1);
			print pre($text2);
		print "</td>\n";
	print "</tr>\n";

	open (FILE,'<',"$fdir/ioccg/giop_eval_stats_$i.txt") or next;
	local($/) = undef;
	my $text3 = <FILE>;
	close (FILE);

	open (FILE,'<',"$fdir/ioccg/giop_eval_diff_$i.txt") or next;
	local($/) = undef;
	my $text4 = <FILE>;
	close (FILE);

	print "<tr>\n";
		print "<td>IOCCG</td>\n";
		print "<td>\n";
			print a({-href=>"$idir/ioccg/giop_eval_scat_$i.png"}, img{-src=>"$idir/ioccg/giop_eval_scat_$i\_sm.png"});
		print "</td>\n";
		print "<td>\n";
			print a({-href=>"$idir/ioccg/giop_eval_diff_$i.png"}, img{-src=>"$idir/ioccg/giop_eval_diff_$i\_sm.png"});
		print "</td>\n";
		print "<td>\n";
			print a({-href=>"$idir/ioccg/giop_eval_histd_$i.png"}, img{-src=>"$idir/ioccg/giop_eval_histd_$i\_sm.png"});
		print "</td>\n";
		print "<td>\n";
			print a({-href=>"$idir/ioccg/giop_eval_stats_$i.png"}, img{-src=>"$idir/ioccg/giop_eval_stats_$i\_sm.png"});
		print "</td>\n";
		print "<td>\n";
			print pre($text3);
			print pre($text4);
		print "</td>\n";
	print "</tr>\n";

	print "</table>\n";
	print (br);

}

print "</center>\n";

standard_footer($path, "Dan Shao / Jeremy Werdell");
exit;


