#!/usr/bin/env perl
####################################
# Display SeaBASS Archive as  HTML  #
#####################################
#
use strict;
require "/data1/www-data/oceancolor.gsfc.nasa.gov/scripts/dirhash2path.pl";
use OBPG::headfoot;
use Date::Manip;
use Math::Round qw(nearest);
use CGI qw(:all);
use CGI::Pretty;
#use CGI::Carp qw(fatalsToBrowser);
use Fcntl;
use MLDBM qw(DB_File);
use File::Find;
no warnings 'File::Find';
$MLDBM::UseDB = 'DB_File';

my $thisScript = $ENV{SCRIPT_NAME};

my $url = $ENV{SCRIPT_URL};
my $restrict = $url =~ /^\/authorized\// ? 1 : 0;

#unless ($restrict){
#    (my $restrict_url = $url) =~ s/seabasscgi/authorized/;
#    print redirect(-url=>$restrict_url);
#}


my (@results,@row);

my $hashfile = '/web/data/landsat/archive_dir';
my %archdir = ();
my $dbm = tie %archdir, 'MLDBM', $hashfile, O_RDONLY, 0644 or die $!;

#### GENERAL CGI INFO ##############################################################################

my $font = '12pt';
$font = '100%' if ($ENV{HTTP_USER_AGENT} =~ /windows/i);

my $style=<<END;
<!--
TD{ font-size: $font; text-align: center; }
TH{ text-align: center; }
-->
END
my %start = (meta=>{author=>"Sean Bailey, Futuretech Corporation"});
#standard_header('Landsat Archive','landsat_index.cgi',$style);
standard_header('Landsat Archive','landsat_index.cgi',\%start,'',1,0,'oceancolor_banner.png');
print h3("Landsat Data Archive Directory");

if (defined $ENV{PATH_INFO}){
    
    my @subdirs = my @p = map {&basic_laundry($_)} split /\//,$ENV{PATH_INFO};
    shift @subdirs;
    shift @p;
    my %hash = &dirhash2path(@subdirs);
    my @rows = (); 
    my $breadcrumb = "$p[$#p]";
    my $cnt = $#p;
    for (my $j=0;$j<$cnt;$j++){
	my $i = $cnt-$j-1;
	pop @p;
	my $path = join('/',@p);
	$breadcrumb = a({-href=>"$thisScript/$path"},$p[$i]) . '/' . "$breadcrumb" ;
    }
    $breadcrumb = a({-href=>"$thisScript"},'/landsat') . '/' . "$breadcrumb";
    print h3("Index of $breadcrumb");
    print hr;
    my $dash = i("-");
    foreach my $k (sort keys %hash){
	my $icon = img({-src=>"/icons/folder.png"});
	if (exists $hash{$k}{size}){
	    if ($k =~ /\.(gif|jpg|png|bpm|pnm|ppm)$/i){$icon = img({-src=>"/icons/image2.png"})}
	    elsif ($k =~ /\.(xls|doc|ppt)/i){$icon = img({-src=>"/icons/binary.png"})}
	    elsif ($k =~ /\.pdf$/i){$icon = img({-src=>"/icons/pdf.png"})}
	    elsif ($k =~ /\.(gz|bz2|Z|zip)$/i){$icon = img({-src=>"/icons/compressed.png"})}
	    elsif ($k =~ /\.tar$/i){$icon = img({-src=>"/icons/tar.png"})}
	    else{$icon = img({-src=>"/icons/text.png"})}
	    my $size = sprintf "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; %s kB",&nearest(1,$hash{$k}{size}/1024.);
	    my $date = sprintf "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;%s",&UnixDate(&ParseDateString("epoch $hash{$k}{mtime}"),'%b %e %Y');
	    push @rows,Tr(td({-style=>'text-align: left;'},[$icon,a({-href=>"/landsat${ENV{PATH_INFO}}/$k"},$k)]),td(["$date","$size"]));
	}
	else{
	    push @rows,Tr(td({-style=>'text-align: left;'},[$icon,a({-href=>"${thisScript}${ENV{PATH_INFO}}/$k"},"$k/")]),td([$dash,$dash]));
	}
    }
    print table(Tr(th(['&nbsp;','Name','Last Modified','Size'])),@rows);
} else {
    my @tld = sort keys %archdir;
    my @rows = (); 
    foreach my $tld (@tld){
	next if $tld =~/^\./;
	push @rows,Tr(td({-style=>'text-align: left;'},a({-href=>"$thisScript/$tld"},$tld)));
    }
    print table(@rows);
}

#standard_footer('seabasscgi/archive_index.cgi',1);
standard_footer('cgi/archive_index.cgi');
untie $dbm;
exit;

##############################################################################
sub print_dir {
    my @subdirs = @_;
#    my $hs='%hash = %{$archdir{' . join("}{",@subdirs) . "}}";
#    eval($hs);
#    my @k = keys %hash;
#    print p("$hs");
    print p("@subdirs");
#    print p("@k");
}

